<?php
if (!defined('MOODLE_INTERNAL')) {
    die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
}

require_once ($CFG->dirroot.'/course/moodleform_mod.php');
require_once ($CFG->dirroot.'/mod/flashchat/functions_chat.php');
class mod_flashchat_mod_form extends moodleform_mod {

	function definition() {
		global $CFG;
		$mform = $this->_form;
		
		if(isset($this->current->add)){
			
		}else{
			$thisurl = 'modedit.php?update='.$this->current->update.'&return='.$this->current->return;
			$mform->addElement('html','<style>.flashchat_h3{text-align:center;} .flashchat_h3 a{ padding:3px 5px; border:1px solid #dedede; background:#eaeaea; }</style>
				<h3 class="flashchat_h3"><a '.(isset($_GET['type'])?'':'class="red"').' href="'.$thisurl.'">Flashchat Setting</a>  <a '.(isset($_GET['type'])?'class="red"':'').' href="'.$thisurl.'&type=adminpanel">Admin Panel</a></h3>');
		
		}
		
		
		if(isset($_GET['type']) && $_GET['type'] == 'adminpanel'){			
			if(isset($this->current->extendserver) && $this->current->extendserver == '2'){
				$mform->addElement('html','<p>Sorry! Admin Panel is not available in the Free Chat Hosting Edition. 123FlashChat Full Version starts at $30. <br />Click the link below to have a live Admin Panel Demo for testing.</p>
					<p style="text-align:center;"><a href="http://www.123flashchat.com/admin-panel-free.html" target="_blank">Live Demo</a></p>');				
			}else{
				$chat_admin_url = $this->current->client_location."admin_123flashchat.swf?init_host=".$this->current->init_host."&init_port=".
					$this->current->init_port;
				if($this->current->extendserver == 1){
					$chat_admin_url .= "&init_group=".$this->current->init_group;				
				}
				$mform->addElement('html','<p style="text-align:center;">
				<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" width="700" height="528">
					<param name=movie value="'.$chat_admin_url.'">
					<param name=quality value="high">
					<param name="menu" value="false">
					<embed src="'.$chat_admin_url.'" quality="high" menu="false" width="80%" height="500" type="application/x-shockwave-flash" pluginspace="http://www.macromedia.com/go/getflashplayer"></embed>
				</object>
			</p>');		
			}			
		}else{			
			//var_dump($this->current);		
			$mform->addElement('html','<script src="'.$CFG->wwwroot.'/mod/flashchat/123flashchat_setting.js"></script>');		
			
			$mform->addElement('header', 'basesetting', get_string('basesettings', 'flashchat'));
			$mform->addElement('text', 'name', get_string('name', 'flashchat'), array('size'=>'64'));
	        $mform->setType('name', PARAM_TEXT);
			
			$mform->addElement('radio', 'extendserver', get_string('Running_mod2', 'flashchat'), get_string('run_m1', 'flashchat') ,0,array('onclick'=>"serverChange('0')"));
			$mform->addElement('static', '','','<span style="font-family: verdana,sans-serif;font-style: italic;">
						Please download and install 123FlashChat first: <a target="_blank" href="http://www.123flashchat.com/download.html"> http://www.123flashchat.com/download.html</a>, 
						and set Chat Client Location to: http://&lt;your chat server domain or ip&gt;:35555/ </span>');
			$mform->addElement('radio', 'extendserver', '', get_string('run_m2', 'flashchat'),1,array('onclick'=>"serverChange('1')"));
			$mform->addElement('static', '','','<span style="font-family: verdana,sans-serif;font-style: italic;">
						<a target="_blank" href="http://www.123flashchat.com/host.html">For paid host</a>, 
						please set the Chat Client Location like this: http://yourhostname.chat.123flashchat.com/ or http://hostservername.123flashchat.com/yourhostname/, 
						<a target="_blank" href="http://www.123flashchat.com/host.html">Buy host</a>
						<a target="_blank" href="http://www.123flashchat.com/host/apply.php">For trial host</a>, 
						please setup Chat Client Location like this: http://trial.123flashchat.com/yourhostname
						Just replace "yourhostname" to the real one when you applied, <a target="_blank" href="http://www.123flashchat.com/host/apply.php">Apply trial host</a>
					</span>');
			
			$mform->addElement('radio', 'extendserver', '', get_string('run_m3', 'flashchat'),2,array('onclick'=>"serverChange('2')"));		
			$mform->addElement('static', '','','<span style="font-family: verdana,sans-serif;font-style: italic;">
						This chat server mode is for testing the basic functions, only 1 room supported, no video chat function, and you don\'t have the administrator of this chat room, 
						you may select the mode 1 or 2 to get the full function and full control of your chat room.
					</span>');
			$mform->setType('extendserver', PARAM_INT);
				
			//show notice start
			if(isset($this->current->extendserver) && $this->current->extendserver == '2'){
				$mform->addElement('html','<div id="s_warn" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="s_warn" >');
			}
			$mform->addElement('static', '',get_string('integrationurl', 'flashchat'),'To integrate users for auto-login to chat, please open the Chat Admin Panel,
							then System Settings > Integration Panel, set authentication URL to:
							<span style="color:red;">http://&lt;Your sharetronix root URL&gt;/mod/flashchat/login_chat.php?username=%username%&password=%password%</span>');
			$mform->addElement('html','</div>');
			//show notice end
			
			//show server host port start
			if(isset($this->current->extendserver) && $this->current->extendserver == '0' ){
				$mform->addElement('html','<div id="s_server_local" >');
				if(isset($this->current->api_url) && validate_client($this->current->api_url) == 0 ){
					$mform->addElement('html','<div id="s_server_local_own" style="display:none;" >');
				}else{
					$mform->addElement('html','<div id="s_server_local_own" >');
				}
			}else{			
				$mform->addElement('html','<div id="s_server_local" style="display:none;" >');
				if(isset($this->current->api_url) && validate_client($this->current->api_url) == 0 ){
					$mform->addElement('html','<div id="s_server_local_own" style="display:none;" >');
				}else{
					$mform->addElement('html','<div id="s_server_local_own" >');
				}
			}
			$mform->addElement('text', 'init_host', get_string('init_host', 'flashchat'), array('size'=>'64'));
			$mform->setType('init_host', PARAM_TEXT);
			$mform->addElement('text', 'init_port', get_string('init_port', 'flashchat'), 'maxlength="5" size="5"');
			$mform->setType('init_port', PARAM_INT);
			$mform->addElement('text', 'init_http_port', get_string('init_http_port', 'flashchat'), 'maxlength="5" size="5"');
			$mform->setType('init_http_port', PARAM_INT);
			$mform->addElement('static','','<span style="color:red;">NOTE:</span>','Default '.get_string('init_host', 'flashchat').'<span style="color:red;">'. $_SERVER['SERVER_NAME'].'</span>; Default '.get_string('init_port', 'flashchat').' <span style="color:red;">51127</span> ; Default '.get_string('init_http_port', 'flashchat').' <span style="color:red;">35555</span>.');
			$mform->addElement('html','</div></div>');
			//show server host port end
			
			//show client location start
			if(isset($this->current->extendserver) && $this->current->extendserver != '2' ){
				$mform->addElement('html','<div id="s_client_loc" >');
			}else{
				$mform->addElement('html','<div id="s_client_loc" style="display:none;" >');
			}
			$mform->addElement('text', 'client_location', get_string('client_location', 'flashchat'), array('size'=>'64'));
			$mform->setType('client_location', PARAM_TEXT);;
			$mform->addElement('html','</div>');
			//show client location end
			
			//show room name start
			if(isset($this->current->extendserver) && $this->current->extendserver == '2' ){
				$mform->addElement('html','<div id="s_room_name" >');
			}else{
				$mform->addElement('html','<div id="s_room_name" style="display:none;" >');
			}
			$mform->addElement('text', 'chat_room_name', get_string('room_name', 'flashchat'), array('size'=>'64'));
			$mform->setType('chat_room_name', PARAM_TEXT);
			$mform->addElement('html','</div>');
			//show room name end		
			
			if(isset($this->current->extendserver) && $this->current->extendserver != '2' ){
				$mform->addElement('html','<div id="s_room_list" >');
			}else{
				$mform->addElement('html','<div id="s_room_list" style="display:none;" >');
			}
			$mform->addElement('checkbox', 'room_list', get_string('room_list', 'flashchat'), '',1);
			$mform->setType('room_list', PARAM_INT);
			$mform->addElement('html','</div>');
			
			$mform->addElement('checkbox', 'user_list', get_string('user_list', 'flashchat'), '',1);
			$mform->setType('user_list', PARAM_INT);
			
			
			$mform->addElement('header', 'flashchatfieldset', get_string('advanced_settings', 'flashchat'));	
			
			$mform->addElement('radio', 'fullscreen', get_string('chatclientsize', 'flashchat'), get_string('customsize', 'flashchat'),0);
			$mform->addElement('text', 'width', get_string('width', 'flashchat'), 'maxlength="5" size="5"');
			$mform->setType('width', PARAM_INT);
			$mform->addElement('text', 'height', get_string('height', 'flashchat'), 'maxlength="5" size="5"');
			$mform->setType('height', PARAM_INT);
			$mform->addElement('radio', 'fullscreen', '', get_string('fullscreen', 'flashchat'),1);
			$mform->setType('fullscreen', PARAM_INT);
			
			if(isset($this->current->extendserver) && $this->current->extendserver == '2' ){
				$mform->addElement('html','<div id="lang_skin" >');
			}else{
				$mform->addElement('html','<div id="lang_skin" style="display:none;" >');
			}
			$mform->addElement('select', 'lang', get_string('language', 'flashchat'), array('auto'=>'Auto detect','en'=>'English','zh-CN'=>'GB Chinese','zh-TW'=>'Big5 Chinese','fr'=>'French',
				'it'=>'Italian','de'=>'German','nl'=>'Dutch','hu'=>'Hungarian','es'=>'Spanish','hr'=>'Croatian','tr'=>'Turkish','ar'=>'Arabic','pt'=>'Portuguese','ru'=>'Russian',
				'lo'=>'Korean','serbian'=>'Serbian','no'=>'Norwegian','ja'=>'Japanese'));	
			$mform->setType('lang', PARAM_TEXT);			
			$mform->addElement('select', 'skin', get_string('skin', 'flashchat'), array('default'=>'Default','green'=>'Green','orange'=>'Orange','red'=>'Red','black'=>'Black','beige'=>'Beige',
				'standard'=>'Standard','clean'=>'Clean','artistic'=>'Artistic'));
			$mform->setType('skin', PARAM_TEXT);
			$mform->addElement('html','</div>');
			if(isset($this->current->extendserver) && $this->current->extendserver != '2' ){
				$mform->addElement('html','<div id="lang_skin2" >');
			}else{
				$mform->addElement('html','<div id="lang_skin2" style="display:none;" >');
			}
			$mform->addElement('static', '',get_string('language', 'flashchat'),'Note: You can set the language in 123FlashChat Admin Panel -&gt; Client Setting -&gt; Language Setting.');
			$mform->addElement('static', '',get_string('skin', 'flashchat'),'Note: You can set the skin in 123FlashChat Admin Panel -&gt; Client Setting -&gt; Skin.');
			$mform->addElement('html','</div>');
			
			$mform->addElement('hidden', 'server_local',isset($this->current->extendserver)? $this->current->extendserver : '',array('id'=>'fc_server_local'));
			
			if(!isset($this->current->extendserver)){
				$mform->addElement('html','<script>document.getElementById("id_extendserver_2").checked = true;
						document.getElementById("s_warn").style.display = "none";
						document.getElementById("s_room_name").style.display = "block";
						document.getElementById("id_chat_room_name").value = "Lobby";						
					</script>');
			}
			
			$this->standard_coursemodule_elements();
			$this->add_action_buttons();
		}
	}
	
}
?>
